'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by rossbille on 22/05/2015.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SignallingClient = function () {
    function SignallingClient(path) {
        _classCallCheck(this, SignallingClient);

        this.path = path;
        this.onId = null;
        this.onClients = null;
        this.onNewClient = null;
        this.onRemove = null;
        this.onMessage = null;

        this.socket = null;
    }

    _createClass(SignallingClient, [{
        key: 'connect',
        value: function connect() {
            var _this = this;

            if (this.onId === null || this.onClients === null || this.onNewClient === null || this.onRemove === null || this.onMessage === null) {
                throw new Error("Please setup all callbacks before trying to connect.");
            }

            this.socket = _socket2.default.connect(this.path, { reconnection: false });

            this.socket.on('id', function (id) {
                _this.onId(id);
            });

            this.socket.on('clients', function (clients) {
                _this.onClients(clients);
            });

            this.socket.on('new client', function (client) {
                _this.onNewClient(client);
            });

            this.socket.on('remove', function (client) {
                _this.onRemove(client);
            });

            this.socket.on('message', function (message) {
                _this.onMessage(message);
            });
        }
    }, {
        key: 'sendMessage',
        value: function sendMessage(message) {
            this.socket.emit('message', message);
        }
    }]);

    return SignallingClient;
}();

exports.default = SignallingClient;